local StoneGate = ...

function registerFbxMaterial(_nameFbxFile, _nameAsset)
    -- Apply building asset processor
    StoneGate:registerAssetProcessor("models/roofs/pointedRoofs/pointedRoof" .. _nameFbxFile .. ".fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
    })

    -- Register default materials
    StoneGate:registerAssetId("models/roofs/pointedRoofs/pointedRoof" .. _nameFbxFile .. ".fbx/Materials/redRoof", StoneGateSetPrefix .. "_POINTED_" .. _nameAsset .. "_RED_TILE_ROOF_MATERIAL")
end

registerFbxMaterial("Main", "MAIN")
registerFbxMaterial("Keep", "KEEP")
registerFbxMaterial("SmallSquaredTower", "SST")
registerFbxMaterial("OctogonalTower", "OTOWER")
registerFbxMaterial("CircularTower", "CIRCULAR")
registerFbxMaterial("SmallCircularTower", "SCT")
registerFbxMaterial("SmallGate", "SGATE")
registerFbxMaterial("Angle45", "A45")

function registerRoofPart(_nameFbxFile, _nameFbx, _nameAsset, _woodenCost, _buildingPartType)
    StoneGate:registerAssetId("models/roofs/pointedRoofs/pointedRoof" .. _nameFbxFile .. ".fbx/Prefab/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration roof part
    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = _woodenCost*_NoSandbox }
		}}
	}
    })
    StoneGate:registerPrefabComponent("models/roofs/pointedRoofs/pointedRoof" .. _nameFbxFile .. ".fbx/Prefab/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = _buildingPartType
    })
end

registerRoofPart( "SmallSquaredTower", "pointedRoof/Sst_PointedRoof2Opposite",              "SST_POINTED_ROOF_2OPPOSITE",               4, "MAJOR" )
registerRoofPart( "SmallSquaredTower", "pointedRoof/Sst_PointedRoof1Opened",                "SST_POINTED_ROOF_1OPENED",                 4, "MAJOR" )
registerRoofPart( "SmallSquaredTower", "pointedRoof/Sst_PointedRoof4Closed",                "SST_POINTED_ROOF_4CLOSED",                 4, "MAJOR" )
registerRoofPart( "SmallSquaredTower", "pointedRoof/Sst_PointedRoof2Adjacent",              "SST_POINTED_ROOF_2ADJACENT",               4, "MAJOR" )
registerRoofPart( "SmallSquaredTower", "pointedRoof/Sst_PointedRoofExtensionAdvanced",      "SST_POINTED_ROOF_EXTENSION_ADVANCED",       1, "MINOR" )
registerRoofPart( "SmallSquaredTower", "pointedRoof/Sst_PointedRoofExtensionStraight",      "SST_POINTED_ROOF_EXTENSION_STRAIGHT",      1, "MINOR" )
registerRoofPart( "SmallSquaredTower", "pointedRoof/Sst_PointedRoofMachicolation2Opposite", "SST_POINTED_ROOF_MACHICOLATION_2OPPOSITE", 5, "MAJOR" )
registerRoofPart( "SmallSquaredTower", "pointedRoof/Sst_PointedRoofMachicolation1Opened",   "SST_POINTED_ROOF_MACHICOLATION_1OPENED",   5, "MAJOR" )
registerRoofPart( "SmallSquaredTower", "pointedRoof/Sst_PointedRoofMachicolation4Closed",   "SST_POINTED_ROOF_MACHICOLATION_4CLOSED",   5, "MAJOR" )
registerRoofPart( "SmallSquaredTower", "pointedRoof/Sst_PointedRoofMachicolation2Adjacent", "SST_POINTED_ROOF_MACHICOLATION_2ADJACENT", 5, "MAJOR" )

registerRoofPart( "SmallGate", "pointedRoof/SGate_PointedRoofA", "SGATE_POINTED_ROOF_A", 6, "MAJOR" )
registerRoofPart( "SmallGate", "pointedRoof/SGate_PointedRoofMA", "SGATE_POINTED_ROOF_MA", 6, "MAJOR" )

registerRoofPart( "Angle45", "pointedRoof/A45_PointedRoofA", "A45_POINTED_ROOF_A", 3, "MAJOR" )
registerRoofPart( "Angle45", "pointedRoof/A45_PointedRoofMA", "A45_POINTED_ROOF_MA", 3, "MAJOR" )

registerRoofPart( "OctogonalTower", "pointedRoof/OctogonalPointedRoof", "OTOWER_POINTED_ROOF", 8, "MAJOR" )

registerRoofPart( "Main", "pointedRoof/Main_PointedRoof2Opposite", "MAIN_POINTED_ROOF_2OPPOSITE", 10, "MAJOR" )
registerRoofPart( "Main", "pointedRoof/Main_PointedRoof1Opened",   "MAIN_POINTED_ROOF_1OPENED",   10, "MAJOR" )
registerRoofPart( "Main", "pointedRoof/Main_PointedRoof4Closed",   "MAIN_POINTED_ROOF_4CLOSED",   10, "MAJOR" )

registerRoofPart( "Keep", "pointedRoof/Keep_PointedRoof3Opened",           "KEEP_POINTED_ROOF_3OPENED",            7, "MAJOR" )
registerRoofPart( "Keep", "pointedRoof/Keep_PointedRoof2Opposite",         "KEEP_POINTED_ROOF_2OPPOSITE",          7, "MAJOR" )
registerRoofPart( "Keep", "pointedRoof/Keep_PointedRoof1Opened",           "KEEP_POINTED_ROOF_1OPENED",            7, "MAJOR" )
registerRoofPart( "Keep", "pointedRoof/Keep_PointedRoof2Adjacent",         "KEEP_POINTED_ROOF_2ADJACENT",          7, "MAJOR" )
registerRoofPart( "Keep", "pointedRoof/Keep_PointedRoof4Opened",           "KEEP_POINTED_ROOF_4OPENED",            7, "MAJOR" )
registerRoofPart( "Keep", "pointedRoof/Keep_PointedRoof4Closed",           "KEEP_POINTED_ROOF_4CLOSED",            7, "MAJOR" )
registerRoofPart( "Keep", "pointedRoof/Keep_PointedRoofExtensionAdvanced", "KEEP_POINTED_ROOF_EXTENSION_ADVANCED", 1, "MINOR" )
registerRoofPart( "Keep", "pointedRoof/Keep_PointedRoofExtensionStraight", "KEEP_POINTED_ROOF_EXTENSION_STRAIGHT", 1, "MINOR" )

registerRoofPart( "CircularTower", "pointedRoof/CircularPointedRoof", "CIRCULAR_POINTED_ROOF", 6, "MAJOR" )

registerRoofPart( "SmallCircularTower", "pointedRoof/SmallCircularPointedRoof", "SCT_POINTED_ROOF", 4, "MAJOR" )
registerRoofPart( "SmallCircularTower", "pointedRoof/SmallCircularPointedRoofMachicolation", "SCT_POINTED_ROOF_MACHICOLATION", 4, "MAJOR" )

StoneGate:registerAssetProcessor("models/roofs/pointedRoofs/pointedRoofPinion.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register Small Squared Tower materials
StoneGate:registerAssetId("models/roofs/pointedRoofs/pointedRoofPinion.fbx/Materials/murChateau", StoneGateSetPrefix .. "_POINTED_ROOFS_PINION_STONE_MANOR_WALL_MATERIAL")

-- Create default minor decoration part registering function 
function registerDefaultMinorDecorationPart(_nameFbxFile, _nameFbx, _nameAsset, _stoneCost)
    StoneGate:registerAssetId("models/roofs/pointedRoofs/" .. _nameFbxFile .. ".fbx/Prefab/decoration/Minor/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_DECORATION_" .. _nameAsset .. "_PREFAB")

    StoneGate:registerAsset({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_DECORATION_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_DECORATION_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_DECORATION_" .. _nameAsset .. "_DESC",
	Category = "DECORATION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_DECORATION_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		ResourceNeededList = {{ -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = _stoneCost*_NoSandbox }
		}}
	}
    })

    StoneGate:registerPrefabComponent("models/roofs/pointedRoofs/" .. _nameFbxFile .. ".fbx/Prefab/decoration/Minor/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR"    })
end

registerDefaultMinorDecorationPart("pointedRoofPinion", "PointedPinionC", "POINTED_PINION_C", 0)
registerDefaultMinorDecorationPart("pointedRoofPinion", "PointedPinionD", "POINTED_PINION_D", 0)
registerDefaultMinorDecorationPart("pointedRoofPinion", "PointedPinionE", "POINTED_PINION_E", 0)
registerDefaultMinorDecorationPart("pointedRoofPinion", "PointedPinionF", "POINTED_PINION_F", 0)
registerDefaultMinorDecorationPart("pointedRoofPinion", "PointedPinionG", "POINTED_PINION_G", 0)
registerDefaultMinorDecorationPart("pointedRoofPinion", "PointedPinionH", "POINTED_PINION_H", 0)
registerDefaultMinorDecorationPart("pointedRoofPinion", "PointedPinionI", "POINTED_PINION_I", 0)
registerDefaultMinorDecorationPart("pointedRoofPinion", "PointedPinionJ", "POINTED_PINION_J", 0)


